{{
*****************************************
* RX version 1.0                        *
* Author: Rich Harman                   *
* Copyright (c) 2009 Rich Harman        *
* See end of file for terms of use.     *
*****************************************


*****************************************************************
 Read RC inputs on 6 pins, output same values on 6 more pins
*****************************************************************
 Coded by Rich Harman  15 Jul 2009
*****************************************************************
 Thanks go to SamMishal for his help getting the counters to work
*****************************************************************

Theory of Operation:

Launch three cogs using the object RX.spin which in turn each start
two counters.

This approach does NOT need the pulses to arrive on the pins in any
certain order, nor does it require the pins to be all connected.

Whatever pulse is received on pin 1 is then sent out to pin 7 and
so on.

}}

VAR

  byte cog[3]
  long stack[60]
  long uS, WaitTime

PUB Start (pins_array_address, pulsewidth_array_address)|i

  uS := clkfreq/1_000_000
  WaitTime := uS * 20_000   'choose this time carefully

  Stop   'call the stop method to stop cogs tha may be already started
  repeat i from 0 to 2
     cog[i] := cognew(readPins(@long[pins_array_address][i*2], @long[pulsewidth_array_address][i*2]), @ stack[i*20]) + 1

PUB Stop | i
    repeat i from 0 to 2
      if cog[i]
        cogstop(cog[i]~ -1)

Pri WaitSignalState(State,PinNo,TimeOut):TimedOut|T

  T := TimeOut+cnt
  repeat until ina[PinNo] == State or cnt => T
  if Cnt => T
     TimedOut := True
'LowRange #> Width <# HighRange

PUB readPins (pins_address, pulsewidth_address)| i,p1,p2

  repeat i from 0 to 1
     spr[8+i]  := %01000 << 26 + long[pins_address][i]   'set the mode and pin for ctra/b
     spr[10+i] := 1                                      ' set frqa/b

  p1 := long[pins_address][0]
  p2 := long[pins_address][1]
  dira[p1]~
  dira[p2]~
  long[pulsewidth_address][0]~          'add these lines to the code to make sure the count is zeroed
  long[pulsewidth_address][1]~
  repeat

     waitPEQ(0 , |< p1,0)                     'wait for low state
     phsa~
     if not WaitSignalState(1,P1,WaitTime)    'wait for high with time out assuming you have pulldowns
        waitPEQ(0   , |< p1,0)                'wait for low state i.e. pulse ended
        long[pulsewidth_address][0] := phsa/uS + 3

        if  phsa/uS + 3 < 500
          long[pulsewidth_address][0] := 0
        if  phsa/uS + 3 > 2520
          long[pulsewidth_address][0] := 0


     waitPEQ(0   , |< p2,0)                   'wait for low state
     phsb~
     if not WaitSignalState(1,P2,WaitTime)    'wait for high with time out assuming you have pulldowns
        waitPEQ(0   , |< p2,0)                'wait for low state i.e. pulse ended
        long[pulsewidth_address][1] := phsb/uS + 3

        if  phsb/uS + 3 < 500
          long[pulsewidth_address][1] := 0
        if  phsb/uS + 3 > 2520
          long[pulsewidth_address][1] := 0

